// ###############
// Klasse VeryLong
// ###############
// Erweiterung des Variablentype LONG, um besonders groe Zahlen
// zu speichern

#ifndef _VeryLong_

#define _VeryLong_
class VeryLong
{
public:
	VeryLong		operator + (VeryLong Wert2);
	VeryLong		operator + (unsigned int Wert2);
	VeryLong		operator - (VeryLong Wert2);
	VeryLong		operator * (VeryLong Wert2);
	VeryLong		operator * (unsigned int Wert2);
	VeryLong		operator / (VeryLong Wert2);
	VeryLong		operator % (VeryLong Wert2);
	VeryLong		operator & (VeryLong Wert2);
	bool			operator < (VeryLong Wert2);
	bool			operator > (VeryLong Wert2);
	bool			operator == (VeryLong Wert2);
	bool			operator != (VeryLong Wert2);
	operator		= (int Wert);
	operator		int();
	void			GetString(char *output);
	void			SetString(const char *input);
	void			GetBin(char *output, int Blocksize);
	void			SetBin(const char *input, int Blocksize);
	int				Len();
	VeryLong		ModExp(VeryLong Potenz, 
				           VeryLong Modulo);
					VeryLong();
					~VeryLong();
private:
	VeryLong		ModExpIntern(VeryLong Potenz, 
                                 VeryLong Modulo, 
                                 VeryLong ModuloStand,
                                 VeryLong PotenzStand);
	int				BytePosConvert(int Count, int Blocksize);
	unsigned int	Zahl;
};

#endif